; Reduced ti86asm.inc for E2 driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
_homeup         equ       4A95h       ; cursror to top left of home screen
_MEMCHK         equ       46BBh       ; ahl = # bytes of free memory
_check_for_var	equ	  46E3h	      ; Checks to see if there is enough
				      ; RAM for this variable: hl=size, 
				      ; OP1=name
;
_vputs                           equ            4AA5h

;
_CREATEREAL    equ      46EBh   ; CREATE REAL VAR OP1, NO INPUTS
;
_CREATECPLX    equ      46F7h   ; CREATE CPLX VAR OP1, NO INPUTS
;
_CREATERCONST  equ      46EFh   ; CREATE REAL CONSTANT VAR OP1, NO INPUTS
_CREATECCONST  equ      46F3h   ; CREATE CPLX CONSTANT VAR OP1, NO INPUTS
;
_CREATERVECT   equ      46FFh   ; CREATE REAL VECTOR OP1, L = # ELEMENTS
_CREATECVECT   equ      4707h   ; CREATE CPLX VECTOR OP1, L = # ELEMENTS
;
_CREATERLIST   equ      470Fh   ; CREATE REAL LIST OP1, HL = # ELEMENTS
_CREATECLIST   equ      4717h   ; CREATE CPLX LIST OP1, HL = # ELEMENTS
;
_CREATERMAT    equ      471Fh   ; CREATE REAL MATRIX OP1, HL = ROW,COL
_CREATECMAT    equ      4727h   ; CREATE CPLX MATRIX OP1, HL = ROW,COL
;
_CREATESTRNG   equ      472Fh   ; CREATE STRING OP1, HL = # BYTES
;
_CREATEEQU     equ      4737h   ; CREATE EQUATION OP1, HL = # BYTES
;
_CREATEPICT    equ      473Bh   ; CREATE PICTURE VAR OP1, NO INPUTS
;
_CREATEPROG    equ      474Fh   ; CREATE PROGRAM VAR OP1, HL = # BYTES
;
_FINDSYM       equ      46CBh   ; LOOK UP VAR
_delvar        equ      475Fh   ; DELETE VAR
;
;
;
;
_flushallmenus  equ     49DCh   ; clear the 86's menu key stacks

; for _vputs
_penCol                   equ         0C37Ch
_penRow                   equ         0C37Dh

; Clear text mem
_clrScrn                         equ            4A82h

;
_asm_exec_ram             equ         0D748h

; Writes b zeros to (hl)
_zeromem	equ	437Bh	

; Gets word at ahl and puts it in de -- Does not re-swap RAM page!
; Destroys ahl...
_get_word_ahl	equ	521Dh

; Sets word at ahl to de
_set_word_ahl	equ	5221h

_inc_ptr_ahl    equ    4637h    ; ahl = ahl + 1

_load_ram_ahl   equ    462Fh

_RAM_PAGE_7     equ    47F3h ; load RAM page 7, symbol table page

